; $Id$

!include "MUI2.nsh"
!include "FileFunc.nsh"

!if ${ARCH} == "x64"
	!define INSTALL_TARGET $PROGRAMFILES64\baretorrent
!else
	!define INSTALL_TARGET $PROGRAMFILES32\baretorrent
!endif

!define BIN "..\bin.${ARCH}.${PLATFORM}"
!define RES "..\src\res"
!define ARP_ROOT "Software\Microsoft\Windows\CurrentVersion\Uninstall"
!define ARP "${ARP_ROOT}\baretorrent"
!define UNINST "$INSTDIR\uninstall.exe"
!define MSVC "C:\Program Files (x86)\Microsoft Visual Studio 11.0\VC"
!define REDIST "${MSVC}\redist\${ARCH}"
!define MAIN "$INSTDIR\baretorrent.exe"
!define SM_DIR "$SMPROGRAMS\baretorrent"

!define FOR_DEBUG 0

!define MUI_ICON "${RES}\icon.ico"
!define MUI_UNICON "${RES}\icon.ico"

Name "baretorrent-${VERSION_STRING}-${PNAME}-${ARCH}"
OutFile "baretorrent-${VERSION_STRING}-${PNAME}-${ARCH}.exe"
SetCompressor lzma
InstallDir ${INSTALL_TARGET}
RequestExecutionLevel admin

VIAddVersionKey "Comments" "baretorrent"
VIAddVersionKey "CompanyName" "baretorrent"
VIAddVersionKey "FileDescription" "baretorrent"
VIAddVersionKey "FileVersion" "${VERSION_STRING}"
VIAddVersionKey "InternalName" "baretorrent"
VIAddVersionKey "LegalCopyright" ""
VIAddVersionKey "OriginalFilename" "baretorrent.exe"
VIAddVersionKey "ProductName" "baretorrent"
VIAddVersionKey "ProductVersion" "${VERSION_RES}"
VIProductVersion "${VERSION_RES}"

!define MUI_ABORTWARNING
!define MUI_COMPONENTSPAGE_SMALLDESC
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_UNPAGE_COMPONENTS
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_LANGUAGE "English"

Section "!baretorrent" baretorrent_section
	SectionIn RO
	SetOutPath $INSTDIR
	
	File "${BIN}\baretorrent.exe"
	
!if ${FOR_DEBUG} != 1
	File /x "*_d.pyd" "${BIN}\*.pyd"
	File /r locales
	File "${BIN}\baretorrent.dll"
	File "${BIN}\boost_python-vc110-mt-1_52.dll"
	File "${REDIST}\Microsoft.VC110.CRT\msvcp110.dll"
	File "${REDIST}\Microsoft.VC110.CRT\msvcr110.dll"
	File "${BIN}\python33.dll"
	File "${BIN}\wxmsw294u_vc_custom.dll"
	File "${BIN}\python33.zip"
	File "${BIN}\..\CHANGELOG"
	File "${BIN}\..\COPYING"
!endif

	WriteUninstaller "${UNINST}"

	${GetSize} "$INSTDIR" "/S=0K" $0 $1 $2
	IntFmt $0 "0x%08X" $0
	WriteRegDWORD HKLM "${ARP}" "EstimatedSize" "$0"
	
	WriteRegStr HKLM ${ARP} "DisplayName" "baretorrent"
	WriteRegStr HKLM ${ARP} "UninstallString" ${UNINST}
	WriteRegStr HKLM ${ARP} "QuietUninstallString" "${UNINST} /S"
	WriteRegStr HKLM ${ARP} "DisplayIcon" "${MAIN},0"
	WriteRegStr HKLM ${ARP} "DisplayVersion" "${VERSION_STRING}"
	WriteRegDWORD HKLM ${ARP} "VersionMajor" "${VERSION_MAJOR}"
	WriteRegDWORD HKLM ${ARP} "VersionMinor" "${VERSION_MINOR}"
SectionEnd

Section "Start menu shortcut" start_menu_section
	CreateDirectory "${SM_DIR}"
	CreateShortCut "${SM_DIR}\Uninstall.lnk" "${UNINST}" "" "${UNINST}"
	CreateShortCut "${SM_DIR}\baretorrent.lnk" "${MAIN}" "" "${MAIN}"
SectionEnd

Section /o "Desktop shortcut" desktop_section
	CreateShortCut "$DESKTOP\baretorrent.lnk" "${MAIN}" "" "${MAIN}"
SectionEnd

Section "!un.baretorrent" unbaretorrent_section
	SectionIn RO

	Delete "$INSTDIR\baretorrent.exe"
	
!if ${FOR_DEBUG} != 1
	Delete "$INSTDIR\*.pyd"
	RMDir /r "$INSTDIR\locales"
	Delete "$INSTDIR\baretorrent.dll"
	Delete "$INSTDIR\boost_python-vc110-mt-1_52.dll"
	Delete "$INSTDIR\msvcp110.dll"
	Delete "$INSTDIR\msvcr110.dll"
	Delete "$INSTDIR\python33.dll"
	Delete "$INSTDIR\wxmsw294u_vc_custom.dll"
	Delete "$INSTDIR\python33.zip"
	Delete "$INSTDIR\CHANGELOG"
	Delete "$INSTDIR\COPYING"
!endif

	Delete "$INSTDIR\Uninstall.exe"
	Delete "$DESKTOP\baretorrent.lnk"
	RMDir /r "${SM_DIR}"
	
	RMDir "$INSTDIR"
	DeleteRegKey HKLM ${ARP}
SectionEnd

Section "un.Preferences" unoptions_section
	RMDir /r "$APPDATA\baretorrent"
SectionEnd

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT \
		${baretorrent_section} "Main application"
	!insertmacro MUI_DESCRIPTION_TEXT \
		${start_menu_section} "Adds a shortcut in the start menu"
	!insertmacro MUI_DESCRIPTION_TEXT \
		${desktop_section} "Adds a shortcut on the desktop"
!insertmacro MUI_FUNCTION_DESCRIPTION_END

!insertmacro MUI_UNFUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT ${unbaretorrent_section} \
		"Main application"
	!insertmacro MUI_DESCRIPTION_TEXT ${unoptions_section} \
		"Deletes the options and the torrent queue (but not the files)"
!insertmacro MUI_UNFUNCTION_DESCRIPTION_END
