#! /bin/sh
# $Id$

if [ $# -ne 2 ] ; then
	echo "linux-release.sh ARCH PLATFORM"
	exit 1
fi

ARCH=$1
BIN=../bin.$ARCH
SRC=../src
VERSION_FILE=$SRC/version.h
SEVENZ=7z
PLATFORM=$2

echo checking $VERSION_FILE

LINE=`grep "#define BARETORRENT_VERSION_MAJOR" $VERSION_FILE`
VERSION_MAJOR=`echo "$LINE" | cut -d " " -s -f 3`
VERSION_MAJOR=`echo "$VERSION_MAJOR" | sed 's/[ \r\n]*$//g'`

LINE=`grep "#define BARETORRENT_VERSION_MINOR" $VERSION_FILE`
VERSION_MINOR=`echo "$LINE" | cut -d " " -s -f 3`
VERSION_MINOR=`echo "$VERSION_MINOR" | sed 's/[ \r\n]*$//g'`

LINE=`grep "#define BARETORRENT_VERSION_MAINTENANCE" $VERSION_FILE`
VERSION_MAINTENANCE=`echo "$LINE" | cut -d " " -s -f 3`
VERSION_MAINTENANCE=`echo "$VERSION_MAINTENANCE" | sed 's/[ \r\n]*$//g'`

if [ -z $VERSION_MAJOR ] ; then
	echo "bad version"
	exit 1
fi

if [ -z $VERSION_MINOR ]  ; then
	echo bad version
	exit 1
fi

VERSION_STRING="${VERSION_MAJOR}.${VERSION_MINOR}"

if [ ! -z $VERSION_MAINTENANCE ] ; then
	VERSION_STRING="${VERSION_STRING}.${VERSION_MAINTENANCE}"
fi

TARGET=baretorrent-${VERSION_STRING}-${PLATFORM}-$ARCH
ARCHIVE=$TARGET.7z

echo copying to $TARGET

mkdir -p "$TARGET"

cp $BIN/baretorrent "$TARGET/"
cp $BIN/*.so "$TARGET/"
cp $BIN/libwx_gtk2u-2.9.so.4 "$TARGET/"
cp $BIN/python33.zip "$TARGET/"
cp ../CHANGELOG "$TARGET/"
cp ../COPYING "$TARGET/"
mkdir -p "$TARGET/res"
cp $SRC/res/* "$TARGET/res"

echo archiving to $ARCHIVE
"$SEVENZ" a "$ARCHIVE" "$TARGET"

rm -Rf "$TARGET"

