<?php
define("bt_include_is_in_script", 1);

require_once(__DIR__ . "/../scripts/ext.php");

class bad_action extends Exception {}
class missing_id extends Exception {}

function exit_404()
{
	header("HTTP/1.0 404 Not Found");
	exit;
}

function exit_500($m = "")
{
	header("HTTP/1.0 500 Internal Server Error");
	echo $m;
	exit;
}

function exit_output($s, $ct)
{
	header("Content-Type: $ct");
	header("Content-Length: " . count($s));
	
	echo $s;
	exit;
}

function exit_redirect($url)
{
	header("Location: $url");
	exit;
}

function icon()
{
	$s = safe_get("size");
	if ($s == "")
		$s = "medium";
	
	$id = (int)$_GET["id"];
	if ($id == 0)
		throw missing_id();

	$e = get_extension($id);

	if ($e == null)
		exit_404();
	
	if (!$e->has_icon())
		exit_redirect("images/default-ext.png");
	
	exit_output($e->icon(), "image/png");
}


$a = safe_get("action");

try
{
	switch ($a)
	{
		case "icon":
		{
			icon();
			break;
		}
		
		default:
		{
			throw new bad_action;
		}
	}
}
catch(missing_id $e)
{
	exit_500("missing id");
}
catch(bad_action $e)
{
	exit_500("bad action");
}

?>