<?php
if (!defined("bt_include_is_in_script"))
{
	header("Location: ../index.html");
	exit;
}

require_once(__DIR__ . "/../utility.php");

function make_forum_path()
{
	// todo
	$f = $_SERVER["PHP_SELF"];

	if (strpos($f, "/forum/") === FALSE)
		return "forum/";
	else
		return "";
}

function make_forum_root_link_impl()
{
	return make_forum_path() . "index.html";
}

function make_forum_link_impl($fid)
{
	return make_forum_path() . "forum.html?id=$fid";
}

function make_thread_link_impl($tid)
{
	return make_forum_path() . "thread.html?id=$tid";
}

function make_post_link_impl($tid, $pid)
{
	return make_forum_path() . "thread.html?id=${tid}#p$pid";
}

function make_user_link_impl($uid)
{
	return "../users.html?id=$uid";
}

function make_feed_link($params)
{
	return make_forum_path() . "feed.php?" . $params;
}

function make_mod_link()
{
	return make_forum_path() . "mod.html";
}

function localized_permissions()
{
	$a = array();
	
	array_push($a, array(
		"name" => loc("permission_post"),
		"value" => user_permission_post));
		
	array_push($a, array(
		"name" => loc("permission_edit_own"),
		"value" =>user_permission_edit_own));

	array_push($a, array(
		"name" => loc("permission_edit_all"),
		"value" => user_permission_edit_all));

	array_push($a, array(
		"name" => loc("permission_erase"),
		"value" => user_permission_erase));

	array_push($a, array(
		"name" => loc("permission_cp"),
		"value" => user_permission_cp));

	array_push($a, array(
		"name" => loc("permission_ban"),
		"value" => user_permission_ban));
	
	array_push($a, array(
		"name" => loc("permission_mod"),
		"value" =>user_permission_mod));
		
	return $a;
}

function permissions_to_string($p, $details = false)
{
	$v = array();
	
	$s = "";
	
	if ($p == user_permission_anonymous)
		$s = loc("permission_anonymous");
	else if ($p == user_permission_registered)
		$s = loc("permission_registered");
	else if ($p == user_permission_administrator)
		$s = loc("permission_administrator");
	
	if (!$details && $s !== "")
		return $s;
		
	$ps = localized_permissions();
	
	foreach ($ps as $pp)
	{	
		if ($p & $pp["value"])
			array_push($v, $pp["name"]);
	}
	
	if (count($v) == 0)
		return loc("permission_none");
	
	$d = implode(" ", $v);
	
	if ($s !== "")
		$s .= " (" . $d . ")";
	else
		$s = $d;
	
	return $s;
}

?>