<?php

function make_section($title, $content)
{
	echo
		"<div class=\"bt_forum_section\">
			" . html::wrap_div("bt_forum_section_title", $title) . "
			<div class=\"bt_forum_section_body\">
			$content
			</div>
		</div>";
}

function output_pagination($total, $per_page, $current_page)
{
	$page_count = ceil($total / $per_page);

	if ($page_count <= 1)
		return;
		
	echo "<div class=\"bt_forum_pagination\">";
	
	if ($current_page != 0)
	{
		$first = make_link_to_self(array("pc" => 0));
		$prev = make_link_to_self(array("pc" => ($current_page - 1)));
		
		echo html::a($first, "|&lt;") . " " . html::a($prev, "&lt;") . " ";
	}
	else
	{
		echo "|&lt; &lt; ";
	}
	
	for ($i=0; $i<$page_count; ++$i)
	{
		$url = make_link_to_self(array("pc" => $i));

		$s = "" . ($i + 1);
		
		if ($i != $current_page)
			$s = html::a($url, $s);
		
		echo $s . " ";
	}
	
	if ($current_page < ($page_count - 1))
	{
		$next = make_link_to_self(array("pc" => ($current_page + 1)));
		$last = make_link_to_self(array("pc" => ($page_count - 1)));
		
		echo " " . html::a($next, "&gt;") . " " . html::a($last, "&gt;|");
	}
	else
	{
		echo " &gt; &gt;|";
	}
	
	echo "</div>";
}

function make_option($name, $type, $value, $help = "", $choices = array())
{
	$s = "	<tr>
				<td class=\"bt_forum_option_row\">$name</td>
				<td class=\"bt_forum_option_row\">";
	
	if ($type == "select")
	{
		$s .= "<select name=\"$name\">";
		
		foreach ($choices as $c)
		{
			$c_value = "";
			$c_caption = "";
			
			if (is_array($c))
			{
				$c_value = $c["value"];
				$c_caption = $c["caption"];
			}
			else
			{
				$c_value = $c;
				$c_caption = $c;
			}
		
			$sel = "";
			if ($c_value == $value)
				$sel = " selected";
			
			$s .= "<option $sel value=\"$c_value\">$c_caption</option>\n";
		}
		
		$s .= "</select>";
	}
	else
	{
		$value_s = "";
		if ($type == "text")
			$value_s = "value=\"$value\"";
		else if ($type == "checkbox")
			$value_s = ($value ? "checked" : "");
		
		$s .= "<input type=\"$type\" name=\"$name\" $value_s />";
	}
	
	$s .= "		</td>
				<td class=\"bt_forum_option_row\">" . $help . "</td>
			</tr>";
	
	return $s;
}

function make_options_table($opts)
{
	$s =
		"<table class=\"bt_forum_cp_options_table\">
			<thead>
				<tr>
					<th>" . loc("cp_option_name") . "</th>
					<th>" . loc("cp_option_value") . "</th>
					<th>" . loc("cp_option_help") . "</th>
				</tr>
			</thead>
			
			<tbody>
				";

	foreach ($opts as $n=>$v)
	{
		$choices = array();
		if (isset($v["choices"]))
			$choices = $v["choices"];
		
		$s .= make_option(
			$n, $v["type"], $v["value"], $v["help"], $choices);
	}
	
	$s .= "
			</tbody>
		</table>";
	
	return $s;
}

?>