<?php
if (!defined("bt_include_is_in_script"))
{
	header("Location: ../index.html");
	exit;
}

class options
{
	private $map = array();
	
	private function __construct()
	{
		$ps = query::get_all_options();
		foreach ($ps as $row)
			$this->map[$row["name"]] = $row["value"];
	}
	
	public static function create()
	{
		return new options();
	}
	
	public static function install_defaults()
	{
		options::add_option("indent", "0");
		options::add_option("readonly", "0");
		options::add_option("moderated", "0");
		options::add_option("base_url", "http://127.0.0.1");
		options::add_option("log_ips", "0");
		options::add_option("auto_reg", "1");
	}
	
	private static function add_option($name, $value)
	{
		$ps = query::find_option($name);
		
		$row = $ps->fetch();
		if ($row !== FALSE)
			return;
		
		query::add_option($name, $value);
	}
	
	
	public function save()
	{
		query::set_options($this->map);
	}
	
	public function indent()
	{
		return (int)$this->map["indent"];
	}
	
	public function set_indent($i)
	{
		$this->map["indent"] = clamp((int)$i, 0, 10);
	}
	
	public function readonly()
	{
		return ($this->map["readonly"] == "0" ? false : true);
	}
	
	public function set_readonly($v)
	{
		$this->map["readonly"] = ($v ? "1" : "0");
	}
	
	public function moderated()
	{
		return ($this->map["moderated"] == "0" ? false : true);
	}
	
	public function set_moderated($v)
	{
		$this->map["moderated"] = ($v ? "1" : "0");
	}
	
	public function base_url()
	{
		return $this->map["base_url"];
	}
	
	public function set_base_url($v)
	{
		$this->map["base_url"] = $v;
	}
	
	public function log_ips()
	{
		return ($this->map["log_ips"] == "0" ? false : true);
	}
	
	public function set_log_ips($v)
	{
		$this->map["log_ips"] = ($v ? "1" : "0");
	}
	
	public function auto_reg()
	{
		return ($this->map["auto_reg"] == "0" ? false : true);
	}
	
	public function set_auto_reg($v)
	{
		$this->map["auto_reg"] = ($v ? "1" : "0");
	}
}

$g_options = null;

function opt()
{
	global $g_options;
	
	if ($g_options === null)
		$g_options = options::create();
	
	return $g_options;
}

?>