// This file is part of baretorrent and is released in the public
// domain. Hopefully, someone can make it better than I could.

#ifndef BARETORRENT_LOG_DIALOG_INCLUDED
#define BARETORRENT_LOG_DIALOG_INCLUDED

#include "ext/ext.h"
#include "custom_list.h"
#include "log.h"

// this contains some simple dialogs and panels

namespace baretorrent
{

class log_dialog : public custom_frame
{
public:
	log_dialog(wxWindow* parent);

private:
	DECLARE_EVENT_TABLE()

	// indices in the log level combo box
	//
	enum log_level_indices
	{
		log_level_error = 0,
		log_level_normal,
		log_level_verbose,
		log_level_very_verbose,
		log_level_ext
	};


	custom_list<log_t::entry>* list_;
	custom_list<ext::instance>* ext_;
	timer timer_;
	log_t::entries new_entries_;
	log_t::entries entries_;
	boost::mutex entries_mutex_;
	log_t::levels level_;
	signal_connections cons_;

	wxPanel* controls(wxWindow* parent);

	void rebuild(log_t::levels lv);
	void insert_items(const log_t::entries& v);
	void rebuild_ext();
	void add_extension(ext::instance_ptr i);

	void on_flushed(const log_t::entry& e);
	bool on_timer();
	void on_clear_log(wxCommandEvent&);
	void on_save_log(wxCommandEvent&);
	void on_level(wxCommandEvent& e);
	void on_ext_checked(int i, bool b);
	void on_close(wxCloseEvent&);
	void on_copy(wxCommandEvent&);

	void on_extension_loaded(ext::instance_ptr i);
	void on_extension_uninstalled(ext::instance_ptr i);
};

}	// namespace baretorrent

#endif	// BARETORRENT_LOG_DIALOG_INCLUDED
