// This file is part of baretorrent and is released in the public
// domain. Hopefully, someone can make it better than I could.

#include "config.h"

#if BARETORRENT_VISUALC

// program wide warnings
#pragma warning(disable: 4514)  // unreferenced inline function
#pragma warning(disable: 4710)  // function not inlined
#pragma warning(disable: 4625)  // copy ctor could not be generated
#pragma warning(disable: 4626)  // assignment op could not be generated
#pragma warning(disable: 4510)  // default ctor could not be generated
#pragma warning(disable: 4610)  // can never be instantiated
#pragma warning(disable: 4512)  // assignment op could not be generated
#pragma warning(disable: 4121)  // alignment
#pragma warning(disable: 4251)  // needs to have dll-interface 
#pragma warning(disable: 4275)  // used as base for DLL-interface 
#pragma warning(disable: 4505)  // unreferenced local function
#pragma warning(disable: 4820)  // padding
#pragma warning(disable: 4686)  // behavior change
#pragma warning(disable: 4996)  // deprecated
#pragma warning(disable: 4640)  // local static is not thread-safe
#pragma warning(disable: 4365)  // signed/unsigned mismatch
#pragma warning(disable: 4503)  // decorated name
#pragma warning(disable: 4350)  // behavior change
#pragma warning(disable: 4711)  // selected for inline expansion
#pragma warning(disable: 4571)  // Informational
#pragma warning(disable: 4258)	// old for loop
#pragma warning(disable: 4371)	// layout changed

// warnings disabled in third parties
#pragma warning(push)
#pragma warning(disable: 4245)  // signed/unsigned mismatch
#pragma warning(disable: 4127)  // conditional expression is constant
#pragma warning(disable: 4946)  // reinterpret_cast 
#pragma warning(disable: 4548)  // expression before comma has no effect
#pragma warning(disable: 4619)  // there is no warning number
#pragma warning(disable: 4640)  // construction of local static object
#pragma warning(disable: 4668)  // not defined as a preprocessor macro
#pragma warning(disable: 4265)  // destructor is not virtual
#pragma warning(disable: 4365)  // signed/unsigned mismatch
#pragma warning(disable: 4820)  // bytes padding added
#pragma warning(disable: 4061)  // switch of enum
#pragma warning(disable: 4242)  // conversion
#pragma warning(disable: 4244)  // conversion
#pragma warning(disable: 4191)  // unsafe conversion
#pragma warning(disable: 4005)  // macro redefinition
#pragma warning(disable: 4263)  // does not override
#pragma warning(disable: 4264)  // no override available
#pragma warning(disable: 4986)  // exception spec does not match
#pragma warning(disable: 4100)  // unreferenced formal parameter
#pragma warning(disable: 4371)  // layout may have changed
#pragma warning(disable: 4099)  // first seen using 'class'
#pragma warning(disable: 4574)  // macro defined to be 0
#pragma warning(disable: 4836)  // lambdas
#pragma warning(disable: 4211)	// redefined extern to static
#pragma warning(disable: 4267)	// possible loss of data
#pragma warning(disable: 4628)	// digraphs
#pragma warning(disable: 4917)	// guid
#pragma warning(disable: 4273)	// inconsistent linkage
#pragma warning(disable: 4250)	// inherits via dominance
#pragma warning(disable: 4555)	// expression has no effect

// https://svn.boost.org/trac/boost/ticket/7663
#pragma warning(disable: 4913)	// operator exists

#elif BARETORRENT_GCC && BARETORRENT_GCC_HAS_DIAGNOSTIC

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wctor-dtor-privacy"
#pragma GCC diagnostic ignored "-pedantic"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#pragma GCC diagnostic ignored "-Wunused-parameter"
#pragma GCC diagnostic ignored "-Wenum-compare"
#pragma GCC diagnostic ignored "-Woverflow"
#pragma GCC diagnostic ignored "-Woverloaded-virtual"

#endif
