// This file is part of baretorrent and is released in the public
// domain. Hopefully, someone can make it better than I could.

#include "config.h"
#include "push_warnings.h"

#if BARETORRENT_USE_DEBUG_PYTHON
#define BOOST_DEBUG_PYTHON 1
#endif

#define BOOST_LINKING_PYTHON
#include <boost/python.hpp>

#include "pop_warnings.h"

void export_libtorrent_module();

namespace baretorrent
{
namespace ext
{

void export_python_module();

}	// namespace ext
}	// namespace baretorrent


BOOST_PYTHON_MODULE(baretorrent)
{
#if BARETORRENT_VISUALC && BARETORRENT_DEBUG
	int of = _CrtSetDbgFlag(0);
	int nf = of & ~_CRTDBG_ALLOC_MEM_DF;

	//todo: crt reports leaks in bpl init
	_CrtSetDbgFlag(nf);
#endif

	baretorrent::ext::export_python_module();

#if BARETORRENT_VISUALC
	_CrtSetDbgFlag(of);
#endif
}
