// This file is part of baretorrent and is released in the public
// domain. Hopefully, someone can make it better than I could.

#ifndef BARETORRENT_RESOURCES_INCLUDED
#define BARETORRENT_RESOURCES_INCLUDED

namespace baretorrent
{
namespace images
{

// these are the images used on the user interface; the platform-
// specific code is in charge of deciding which icon to use (different
// platforms have different icon sizes) and from where (windows uses
// resources, osx uses bundles, etc.)
//
enum image
{
	add = 1,
	remove,
	resume,
	pause,
	up,
	down,
	top,
	bottom,
	active,
	upload,
	download,
	inactive,
	all,
	creeper,
	icon_16,
	icon_24,
	icon_32,
	icon_48,
	icon_64,
	icon_128,
	icon_256,
	icon_512,
	close_search,
	pcon_16
};

}	// namespace images

// the bad image is hardcoded in resources.cpp; this is returned when
// loading the image failed
//
wxBitmap make_bad_image();

}	// namespace baretorrent

#endif	// BARETORRENT_RESOURCES_INCLUDED
